(function (global) {
    var unsupportedOsList = {
        windows: [
            "nt 3.1",
            "nt 3.5",
            "nt 3.51",
            "nt 4.0",
            "nt 5.0",
            "nt 5.1",
            "nt 5.2",
            "nt 6.1",
            "nt 6.2"
        ]
    };

    function checkIgnore() {
        var userAgent = navigator.userAgent.toLocaleLowerCase();
        var osInfo = getOsInfo(userAgent);
        return !isSupportedOs(osInfo);
    }

    function getOsInfo(userAgent) {
        var osInfo;
        if (userAgent.indexOf("windows") > 0) {
            osInfo = getWindowsOsInfo(userAgent);
        } else {
            osInfo = {type: "", version: ""};
        }
        return osInfo;
    }

    function getWindowsOsInfo(userAgent) {
        var windowsPattern = /.*windows (nt \d+\.\d+).*/;
        var type = "windows";
        var version = userAgent.match(windowsPattern)[1];
        return {type: type, version: version};
    }

    function isSupportedOs(osInfo) {
        if (osInfo.type in unsupportedOsList) {
            return unsupportedOsList[osInfo.type].indexOf(osInfo.version) === -1;
        }
        return true;
    }
    global.checkIgnore = checkIgnore;
})(this);